#include<stdio.h>
#include<stdlib.h>
#include<string.h>
/* generates combinations of k elements from the set of size n, k<=n*/

struct Combination
{
  unsigned int n;
  unsigned int k;
  double num_comb;
  unsigned int *comb;
};

struct featureList
{
  int **S;
  int *g;
  int n;
  int *motif;
};


void printmotif(int *motif, int k)
{
  int i;
  for (i = 0; i < k; ++i)
    printf("%d ", motif[i]);
  printf("\n");
}

void printfeaturelist(int **L, int n, int k, int nprint)
{
  int i, j;
  for (i = 0; i < nprint; ++i)
    printmotif(L[i],k);
}

unsigned int factorial(unsigned int n)
{
  if (n == 0) return 1;
  return n*factorial(n-1);
}

double nchoosek(double n, double k)
{
  int i;
  double *nums, *dens;
  double prod;
  if (k > n/2) k=n-k;
  if (k==0) return 1;
  if (k==1) return n;
  if (k > 1)
  { 
    nums = malloc(k*sizeof(double));
    dens = malloc(k*sizeof(double));
    for (i = 0; i < k; ++i)
    {
       nums[i] = n-k+1+i;
       dens[i] = i+1;
    }  
    prod = 1;
    for (i = 0; i < k; ++i)
    {
      nums[i] = nums[i] / dens[i];
      prod = prod * nums[i];
    }
  }
  return prod;
}

void traversecombinations(const int *elems, unsigned int n, unsigned int k, int *pos, unsigned int depth, unsigned int margin, int *cnt_comb, int *out, int num_comb)
{
 int j;
 if (depth >= k)
 {
    //printf("%d: ", cnt_comb[0]);
    for (j = 0; j < k; ++j)
    {
       out[cnt_comb[0] + j*num_comb] = elems[pos[j]];
       //printf("%d ", elems[pos[j]]);
    }
    cnt_comb[0]++;    
    printf("\n");
    return; 
 }
 for (j = margin; j < n; ++j)
 {
    pos[depth]=j;
    traversecombinations(elems, n, k, pos, depth + 1, j + 1, cnt_comb, out, num_comb);    
 }
}

struct featureList *getSharedKmers(int *a, int *b, int k, int m, struct Combination **combinations)
{
   struct featureList *P;
   int **Motifs;
   int *midx, *comb, *comb1, *comb11, *remainingPos, *motif, *motif1;
   int *fixedComb, *fixedComb1, *remainingComb, *remainingComb1, *isFixed;
   int *motif2, *incomb, *outcomb, *incomb1, *outcomb1;
   int *remainingmidx, *remainingmidx1;
   unsigned char *isMismatch;
   int d, da, db;
   int nmotif;
   int i,j,ii,jj,jjj,ji,jo,r,ncomb,ncomb1, nincomb, noutcomb;
   int nincards, noutcards, nincardsmax, noutcardsmax;
   midx = malloc(k*sizeof(int));
   isMismatch = malloc(k*sizeof(char));
   comb1 = malloc(k*sizeof(int));   
   comb11 = malloc(k*sizeof(int));   
   incomb1 = malloc(k*sizeof(int));   
   outcomb1 = malloc(k*sizeof(int));   
   remainingPos = malloc(k*sizeof(int));   
   remainingComb = malloc(k*sizeof(int));   
   remainingmidx = malloc(k*sizeof(int));
   remainingmidx1 = malloc(k*sizeof(int));
   remainingComb1 = malloc(k*sizeof(int));   
   fixedComb = malloc(k*sizeof(int));   
   fixedComb1 = malloc(k*sizeof(int));   
   isFixed = malloc(k*sizeof(int));   
   motif = malloc(k*sizeof(int));   
   motif1 = malloc(k*sizeof(int));   
   motif2 = malloc(k*sizeof(int));   
   Motifs = malloc(k*nchoosek(k,m)*sizeof(int *));
   nmotif = 0;
   /* Get number of mismatches d and mismatch positions midx*/
   d = 0;
   r = 0;
   for (i = 0; i < k; ++i)
   {
     isMismatch[i] = 0;
     if (a[i]!=b[i])
     {
        isMismatch[i] = 1;
        midx[d++] = i;
     }
     else
     {
       remainingPos[r++]=i;  
     }    
   } 

   //HACK!!!!
   if (d <= 2*m)
     {
       Motifs[0] = malloc(k*sizeof(int));
       Motifs[1] = malloc(k*sizeof(int));
       for (ii = 0; ii < k; ++ii)
         {
           Motifs[0][ii] = a[ii];
           Motifs[1][ii] = b[ii];
         }
       nmotif = 2;
     }
   //

   if (d <= m)
   {
      for (jo = 0; jo <= m-d; ++jo)
        {
          comb = combinations[k-d][jo].comb;
          ncomb = combinations[k-d][jo].num_comb;
          for (j=0; j < ncomb; ++j)
            {
              for (ii = 0; ii < k; ++ii)
                //if (isMismatch[ii])
                //  motif[ii] = -1;
                //else
                  motif[ii] = a[ii];
              for (ii = 0; ii < jo; ++ii)
                motif[remainingPos[comb[j+ii*ncomb]]]=-1;
              // Output motif
              Motifs[nmotif] = malloc(k*sizeof(int));
              for (ii = 0; ii < k; ++ii)
                Motifs[nmotif][ii] = motif[ii]; 
              ++nmotif;
            }   
        }

      for (i = 1; i <= d; ++i)
      {
        fixedComb = combinations[d][i].comb;
        ncomb = combinations[d][i].num_comb;
        for (j = 0; j < ncomb; ++j)
        {
           for (jj = 0; jj < i; ++jj)
             fixedComb1[jj] = fixedComb[j + jj*ncomb];
           for (jj = 0; jj < k; ++jj)
             motif[jj] = a[jj];
           for (jj = 0; jj < i; ++jj)
             motif[midx[fixedComb1[jj]]] = b[midx[fixedComb1[jj]]];
           for (jj = 0; jj < d; ++jj)
             remainingmidx1[jj] = 1;
           for (jj = 0; jj < i; ++jj)
             remainingmidx1[fixedComb1[jj]] = 0;
           r = 0;
           for (jj = 0; jj < d; ++jj)
             if (remainingmidx1[jj]==1)
                 remainingmidx[r++]=jj;  
           da = i;
           db = d - i;
           noutcardsmax = da > db ? m - da : m - db;
           for (noutcards = 0; noutcards < noutcardsmax; ++noutcards)
             {
               outcomb = combinations[k-d][noutcards].comb;
               noutcomb = combinations[k-d][noutcards].num_comb;
               for (jo = 0; jo < noutcomb; ++jo)
                 {
                   for (jj = 0; jj < noutcards; ++jj)
                     outcomb1[jj] = outcomb[jo+jj*noutcomb];
                   for (jj = 0; jj < k; ++jj)
                     motif1[jj] = motif[jj];
                   for (jj = 0; jj < noutcards; ++jj)
                     motif1[remainingPos[outcomb1[jj]]] = -1;

                   nincardsmax = da > db ? da - i : db - i;
                   //nincardsmax = m - i - noutcards;
                   if (nincardsmax > 0)
                   {
                    for (nincards=0; nincards < nincardsmax; ++nincards)
                     {
                       if (nincards > 0)
                        {
                         incomb = combinations[d-i][nincards].comb;
                         nincomb = combinations[d-i][nincards].num_comb;
                         for (ji = 0; ji < nincomb; ++ji)
                           {
                             for (jj = 0; jj < k; ++jj)
                               motif2[jj] = motif1[jj];
                             for (jj = 0; jj < nincards; ++jj)
                               motif2[midx[remainingmidx[incomb[ji+jj*nincomb]]]] = -1; 
                             // Output motif
                             Motifs[nmotif] = malloc(k*sizeof(int));
                             for (jj = 0; jj < k; ++jj)
                               Motifs[nmotif][jj] = motif2[jj];
                             ++nmotif;
                           } 
                        } 
                       else
                        {
                          Motifs[nmotif] = malloc(k*sizeof(int));
                          for (jj = 0; jj < k; ++jj)
                            Motifs[nmotif][jj] = motif1[jj];
                          ++nmotif;
                        }
                     }
                   }
                   else
                   {
                     
                          Motifs[nmotif] = malloc(k*sizeof(int));
                          for (jj = 0; jj < k; ++jj)
                            Motifs[nmotif][jj] = motif1[jj];
                          ++nmotif;
                   }  
             }
      }     
     } 
}
   }
   else
   {
     if (d > m && d <= 2*m)
     {
        for (i = d - m; i <= m; ++i)
        {
           fixedComb = combinations[d][i].comb;
           ncomb = combinations[d][i].num_comb;
           for (j = 0; j < ncomb; ++j)
           {
              for (ii = 0; ii < k; ++ii)
                 motif[ii] = a[ii];

              for (ii = 0; ii < i; ++ii)
                 fixedComb1[ii] = fixedComb[j + ii*ncomb];

              r = 0;
              for (ii = 0; ii < d; ++ii)
                isFixed[ii] = 0;
              for (ii = 0; ii < i; ++ii)
                isFixed[fixedComb1[ii]] = 1; 
              for (ii = 0; ii < d; ++ii)
                if (!isFixed[ii])
                   remainingComb1[r++]=ii;     
              for (ii = 0; ii < i; ++ii)
                motif[midx[fixedComb1[ii]]] = b[midx[fixedComb1[ii]]];
              da = i;
              db = d-i;
              if (da<m)
              {
                //for (ii = 1; ii <= m-da; ++ii)
                for (ii = 0; ii <= m-da; ++ii)
                {
                   comb1 = combinations[d-i][ii].comb;
                   ncomb1 = combinations[d-i][ii].num_comb;
                   for (jj = 0; jj < ncomb1; ++jj)
                   {
                      for (jjj = 0; jjj < ii; ++jjj)
                        comb11[jjj] = comb1[jj + jjj*ncomb1];
                      for (jjj = 0; jjj < k; ++jjj) 
                        motif1[jjj] = motif[jjj];
                      for (jjj = 0; jjj < ii; ++jjj)
                        motif1[midx[remainingComb1[comb11[jjj]]]] = -1;
                      // Output motif 
                      //printmotif(motif1, k);
                      Motifs[nmotif] = malloc(k*sizeof(int));
                      for (jjj = 0; jjj < k; ++jjj)
                        Motifs[nmotif][jjj] = motif1[jjj]; 
                      ++nmotif;
                   }
                }

              }
              else
              {
                 if (2*m-d==0)
                 //if (da == m)
                 {
                  // Output motif
                  //printmotif(motif, k); 
                  Motifs[nmotif] = malloc(k*sizeof(int));
                  for (ii = 0; ii < k; ++ii)
                     Motifs[nmotif][ii] = motif[ii]; 
                  ++nmotif;
                 } 
              }  
           }
        }

     }

   }   

   free(midx);
   free(isMismatch);
   free(remainingPos);
   free(remainingmidx);
   free(remainingmidx1);
   free(isFixed);
   free(motif);
   free(motif1);
   free(motif2);

   P = malloc(sizeof(struct featureList));
   (*P).S = Motifs;
   (*P).n = nmotif; 
   return P;
}

int **generatePlantedMotifInput(int na, int N, int n, int k, int m, int maxFreq)
{
  
  int **S;
  int *motif, *plantPos, *motif1, *mutPos, *mutChar;
  int i, j, nmut;

  // Generate N strings of length n each over alphabet na
  S = malloc(N*sizeof(int *));
  for (i = 0; i < N; ++i)
     S[i] = malloc(n*sizeof(int));
  for (i = 0; i < N; ++i)
     for (j = 0; j < n; ++j)
       S[i][j] = rand() % na;  

  // Generate motif of length k
  motif = malloc(k*sizeof(int));
  for (i = 0; i < k; ++i)
    motif[i] = rand() % na;

  printf("Planting...");
  printmotif(motif,k);

  // Generate random positions for motif
  plantPos = malloc(N*sizeof(int));
  for (i = 0; i < N; ++i)
    plantPos[i] = rand() % n-k+1; 
   

  // Plant motif
  mutChar = malloc(m*sizeof(char));
  mutPos = malloc(m*sizeof(int));
  motif1 = malloc(k*sizeof(int));
 
  for (i = 0; i < N; ++i)
  {
    // Mutate motif for planting
    nmut = rand() % (m+1);
    for (j = 0; j < nmut; ++j)
    {
      mutPos[j] = rand() % k;
      mutChar[j] = rand() % na;
    }
    for (j = 0; j < k; ++j)
      motif1[j] = motif[j];
    for (j = 0; j < nmut; ++j)
      motif1[mutPos[j]]=mutChar[j];
    // Plant mutated copy
    for (j = 0; j < k; ++j)
      S[i][plantPos[i]+j] = motif1[j];
  }
  return S;
}


struct featureList *extractKmers(int **S, int N, int n, int k)
{
  int **sx;
  int *g;
  struct featureList *List; 
  int i, j, jj, nkmer;
  // Extract k-mers and store in sx
  List = malloc(sizeof(struct featureList));
  sx = malloc((n-k+1)*N*sizeof(int *));  
  g = malloc((n-k+1)*N*sizeof(int));  
  nkmer = 0;
  for (i = 0; i < N; ++i)
    for (j = 0; j < n - k + 1; ++j)
    {
       sx[nkmer] = malloc(k*sizeof(int));
       for (jj = 0; jj < k; ++jj)
         sx[nkmer][jj] = S[i][j+jj];
       g[nkmer] = i;
       ++nkmer;
    }
  printf("Extracted %d k-mers...\n", nkmer);
  (*List).S = sx;
  (*List).g = g;
  (*List).n = nkmer;
  return List; 
}



char *selectionq_sel(int **P, int **S, int *g, int np, int ns, int k, int m, int nStr, int t, int *selected_stems)
{
  int *ucnt;
  char *isMotif;
  int i, j, jj, mcnt, scnt, wcnt, motifcnt;
  char allnonstar;
  ucnt = malloc(nStr*sizeof(int));
  isMotif = malloc(np*sizeof(char));
  motifcnt = 0;
  for (i = 0; i < np; ++i) /* for every pattern candidate */
  {
    isMotif[i]=0;
    for (j = 0; j < nStr; ++j)
       ucnt[j] = 0;    
    scnt = 0;
    for (j = 0; j < ns && selected_stems[j]>=0; ++j) /* for every input k-mer */
    { 
      int j_sel = selected_stems[j];
      if (j_sel >=0)
      {
       if (ucnt[g[j_sel]]==0)
       {
         mcnt = 0;
         wcnt = 0; 
         for (jj = 0; jj < k; ++jj)
         {
           mcnt+=(P[i][jj] != S[j_sel][jj]);
           wcnt+=(P[i][jj] == -1);
         }
         
         //if ((mcnt <= m) || (wcnt > 0 && mcnt - 1 <= m))
         //if (mcnt - wcnt <= m)
         if (mcnt <= m)
         //if ((wcnt==0 && mcnt <= m) ||(wcnt>0 && mcnt==wcnt))
         {
           /*
           if (wcnt > 0 && mcnt > wcnt)
             {
              printf("Extra motif: ");
              printmotif(S[i],k); 
             }
           */
           ucnt[g[j_sel]]++;
           ++scnt;
         } 
       } 

       if (j>0)
       {
          // break if string does not contain a motif instance
           if (g[j_sel] != g[selected_stems[j-1]] && ucnt[g[selected_stems[j-1]]]==0)
           {
             //printf("terminating search...\n");
             //printmotif(P[i],k);
             //printf("missing in %d\n", g[j-1]);
             break;
           }
       }
     }
    }  
    if (scnt>=t)
    {
      printf("Found motif: #string = %d\n", scnt);
      printf("scnt=%d, i=%d\n", scnt, i);
      isMotif[i] = 1;
      printmotif(P[i],k);
      ++motifcnt;
    }
  }
  return isMotif;   
}

char *selectionq(int **P, int **S, int *g, int np, int ns, int k, int m, int nStr, int t)
{
  int *ucnt;
  char *isMotif;
  int i, j, jj, mcnt, scnt, wcnt, motifcnt;
  char allnonstar;
  ucnt = malloc(nStr*sizeof(int));
  isMotif = malloc(np*sizeof(char));
  motifcnt = 0;
  for (i = 0; i < np; ++i) /* for every pattern candidate */
  {
    isMotif[i]=0;
    for (j = 0; j < nStr; ++j)
       ucnt[j] = 0;    
    scnt = 0;
    for (j = 0; j < ns; ++j) /* for every input k-mer */
    {
       if (ucnt[g[j]]==0)
       {
         mcnt = 0;
         wcnt = 0; 
         for (jj = 0; jj < k; ++jj)
         {
           mcnt+=(P[i][jj] != S[j][jj]);
           wcnt+=(P[i][jj] == -1);
         }
         
         if (mcnt - wcnt <= m)
         //if (mcnt <= m)
         //if ((wcnt==0 && mcnt <= m) ||(wcnt>0 && mcnt==wcnt))
         {
           /*
           if (wcnt > 0 && mcnt > wcnt)
             {
              printf("Extra motif: ");
              printmotif(S[i],k); 
             }
           */
           ucnt[g[j]]++;
           ++scnt;
         } 
       } 

       if (j>0)
       {
          // break if string does not contain a motif instance
           if (g[j] != g[j-1] && ucnt[g[j-1]]==0)
           {
             //printf("terminating search...\n");
             //printmotif(P[i],k);
             //printf("missing in %d\n", g[j-1]);
             break;
           }
       }

    }  
    if (scnt>=t)
    {
      printf("scnt=%d, i=%d\n", scnt, i);
      isMotif[i] = 1;
      printmotif(P[i],k);
      ++motifcnt;
    }
  }
  return isMotif;   
}

void writeList(int **L, int n, int k, char *filename)
{
  int i, j;
  FILE *outfile;
  outfile = fopen(filename, "w"); 
  for (i = 0; i < n; ++i)
  {
     for (j = 0; j < k; ++j)
     {
        fprintf(outfile, "%d ", L[i][j]);
     }
     fprintf(outfile, "\n"); 
  }
  fclose(outfile);  
}

int **readList(char *filename, int N, int n)
{
  int i, j;
  int **L;
  char *line, *a;
  FILE *infile;
  L = malloc(N*sizeof(int *));
  line = malloc(n*n*sizeof(char));
  infile = fopen(filename, "r");
  for (i = 0; i < N; ++i)
    { 
      L[i] = malloc(n*sizeof(int));
      fgets(line, n*n, infile);
      a = NULL;
      a = strtok(line, " ");
      j = 0;
      while (a!=NULL)
        {
         
           L[i][j] = atoi(a);
           ++j;
           a = strtok(NULL, " ");
        } 
    }
  return L;
}


int *
count_sort (int **P, int n, int k, int na)
{
  // returns index vector containing ordering permutation for P
  // P is n-by-k array with each row containing k-mer
  int i, j;
  int *sxc, *sxl, *cc, *bc, *regroup;
  sxc = malloc(na*sizeof(int));
  sxl = malloc(n*sizeof(int));
  cc  = malloc(n*sizeof(int));
  bc  = malloc(na*sizeof(int));
  regroup = malloc(n*sizeof(int));
  for (i = 0; i < n; ++i)
    regroup[i] = i;
  for (j = k-1; j >= 0; --j)
  {
     for (i = 0; i < na; ++i)
 	sxc[i]=0;
     for (i = 0; i < n; ++i)
     {
        cc[i]=P[regroup[i]][j];
        sxc[ cc[i] ]++;
     }
     bc[0]=0;
     for (i = 1; i < na; ++i)
       bc[i] = bc[i-1] + sxc[i-1];
     for (i = 0; i < n; ++i)
       sxl[ bc[cc[i]]++ ] = regroup[i];
     for (i = 0; i < n; ++i)
       regroup[i] = sxl[i];
  }
  free(sxc); free(sxl); free(cc); free(bc);
  return regroup;
}

int *get_unique (int **P, int n, int k, int na)
{
  int i, j, nunique;
  int *current_feat;
  int *sort_idx, *unique_idx;
  char is_same;
  unique_idx = malloc(n*sizeof(int));
  sort_idx = count_sort(P,n,k,na);
  unique_idx[0]=sort_idx[0];  
  nunique = 1;
  i = 1;
  while (i < n)
  { 
    current_feat = P[sort_idx[i]];
    is_same = 1;
    while (is_same && i < n)
    {
      for (j = 0; j < k; ++j)
        if (current_feat[j] != P[sort_idx[i]][j])
        {
           is_same = 0;
           break; 
        }
      ++i;
    }
    if (i < n) unique_idx[nunique++] = sort_idx[i];
  }
  unique_idx[nunique+1]=-1;
  return unique_idx;
}




int *select_stems(int **L, int *g, int n, int k, int m, int nstr, int t)
{
  int i, j, jj;
  int mcnt, scnt, nselected;
  int *selected, *ucnt, *a;
  i = 0;
  selected = malloc(n*sizeof(int));
  ucnt = malloc(nstr*sizeof(int));
  nselected = 0;
  while (i < n) /*(g[i] == 0 && i < n)*/
    {
      selected[i] = 0;
      for (j = 0; j < nstr; ++j) ucnt[j] = 0;
      a = L[i];
      scnt = 0;
      for (j = 0; j < n; ++j)
        {
          mcnt = 0;
          for (jj = 0; jj < k; ++jj)
            mcnt+=a[jj]!=L[j][jj];
          ucnt[g[j]]+=mcnt<=2*m;//2*m;
        }
      for (j = 0; j < nstr; ++j) scnt += (ucnt[j]>0);
      if (scnt>=t)
        {
          selected[nselected++] = i;
          printf("Selected stem: %d, %d\n",i,g[i]);
          printmotif(a,k);
          //++nselected;
        }
      ++i;
    }
  free(ucnt);
  printf("Selected %d stems\n", nselected);
  selected[nselected]=-1;
  return selected;
}



int main(int argc, char *argv[])
{
  struct featureList *P1;
  int **S, **L, **P;
  struct featureList *S1;
  int *elems, *pos, *g;
  char *isMotif;
  unsigned int n, k, depth, margin, m;
  int *cnt_comb;
  int i, j, ii, jj, jjj;
  int *a, *b;
  int na, N, maxFreq, thres, ns, np, dist;
  int hasMotif;
  unsigned long int stat_npairs, stat_npatterns, stat_nstems;
  int *selected_stems;
  if (argc != 3)
  {
     fprintf(stderr, "Error: incorrect number of arguments\n");
     fprintf(stderr, "Usage: generate_combinations n k\n");
     return 1;
  }
  n = atoi(argv[1]); /* motif length */
  k = atoi(argv[2]); /* # mismatches */
  struct Combination **combinations;
  if (n>0 && k<=n)
  {
    printf("size=%d\n",sizeof(struct Combination)); 
    combinations = malloc((n+1)*sizeof(struct Combination *));
    cnt_comb = malloc(sizeof(int));
    for (i = 0; i <= n; ++i)
	combinations[i] = malloc((i+1) * sizeof(struct Combination));
    for (i = 0; i <= n; ++i)
    {   
        for (j = 0; j <= i; ++j)
        {
          cnt_comb[0] = 0;
          combinations[i][j].n = i;
          combinations[i][j].k = j;
          combinations[i][j].num_comb=1;
          if (i > 0 && j > 0)
          {
          combinations[i][j].num_comb = nchoosek(i,j);
          combinations[i][j].comb = malloc(combinations[i][j].num_comb*j*sizeof(int)); 
          elems = malloc((i+1)*sizeof(int));
          pos   = malloc((j+1)*sizeof(int));
          depth = 0;
          margin = 0;
          for (ii = 0; ii < i; ++ii)
            elems[ii] = ii;//+1;
          traversecombinations(elems, i, j, pos, depth, margin, cnt_comb, combinations[i][j].comb,combinations[i][j].num_comb);
          
          //printf("(i,j)=%f\n", nchoosek(i,j));
          //printf("#comb: %f, %d, %d, %d\n", combinations[i][j].num_comb, cnt_comb[0], i, j); 
          free(elems);
          free(pos);
          }
      
        }
    }
  }
  printf("n=%d\n",n); 
  a = malloc(n*sizeof(int));
  b = malloc(n*sizeof(int));
  /* 
  for (ii = 0; ii < n; ++ii)
  {
     a[ii] = 0;
     b[ii] = 0;
  } 
  b[n-1]=1;
  b[n-2]=1; 
  m = 3;  
  P1 = getSharedKmers(a,b,n,m,combinations);
  P = (*P1).S;
  np = (*P1).n;
  printfeaturelist(P,np,n,np);
  */
  //getchar();
  na=20; n=469; N=9; k=11; m=5; maxFreq = 3;
  na=4; n=600; N=20; k=13; m=4; maxFreq = 3;
  na=50; n=600; N=20; k=15; m=5; maxFreq = 3;
  thres = 5; 
  thres = 20; 
  printf("Generating motif input...\n");
  //getchar();
  //S = readList("inpecoli105.txt",N,n);
  //S = readList("lipocalin_cut178.txt",N,n);
  //S = readList("zinc_metallopeptidase_9seq_cut469.txt",N,n);
  //S = readList("immunoglobin_cut13seq_cut278.txt",N,n);
  //S = readList("music20.txt",N,n);
  S = readList("sampleinputs/inpk15m5a50.txt",N,n);
  //S = readList("3dseq_cut78.txt",N,n);
  //S = readList("3dseq_cut78_last4.txt",N,n);
  //S = readList("2Emotif_12seq_cut86.txt",N,n);
  //printfeaturelist(S,N,n,N);
  //getchar();
  //S = generatePlantedMotifInput(na,N,n,k,m,maxFreq);
  writeList(S,N,n,"plantedmotif.input");
  printf("Extracting k-mers...\n");
  S1 = extractKmers(S,N,n,k);
  printf("Searching for motifs...\n");
  L = (*S1).S;
  g = (*S1).g;
  ns = (n-k+1)*N;

  /* selects potential motif instances */ 
  selected_stems = select_stems(L,g,ns,k,m,N,thres);
  thres = 20;
  //printfeaturelist(L,ns,k,100); 
  //printfeaturelist(S,ns,k,100); 
  //for (i = 0; i < ns; ++i)
  //  printf("g[%d]=%d\n",i,g[i]);
  //getchar();  
  stat_npairs = 0;
  stat_npatterns = 0;
  stat_nstems = 0;

//  for (i = 0; i < n-k+1; ++i)
//  { 
  i = 0;
  //while (selected_stems[i] >=0 && i < n)
  while (g[selected_stems[i]]==0 && i < n)
  {
     printf("selected_stems[%d]=%d",i,selected_stems[i]); 
     if (i % 100 == 0) 
     {
       printf(".");
       fflush(stdout);
     }
     printf("Checking %dth kmer...\n", i);
     //for (j = 0; j < k; ++j)
     //  a[j] = S[0][i+j];
     for (j = 0; j < k; ++j)
       a[j] = L[selected_stems[i]][j];
     //printmotif(a,k);
     hasMotif = 0;
    //if (g[selected_stems[i]]==0)
    //{
     for (j = 0; j < n & selected_stems[j]>=0; j++)
       {
        if (g[selected_stems[j]]!=g[selected_stems[i]])//0)
        {
          dist = 0;
          for (jjj = 0; jjj < k; ++jjj) 
          {
             b[jjj] = L[selected_stems[j]][jjj]; //S[j][jj+jjj];
             //printf("%d",b[jjj]);
             if (a[jjj]!=b[jjj]) ++dist;
          }
          if (dist <= 2*m)
          {
            //printf("getting shared kmers...\n");
            //printf("a="); printmotif(a,k);  
            //printf("b="); printmotif(b,k);
            
            ++stat_npairs;
            P1 = getSharedKmers(a,b,k,m,combinations);
            P = (*P1).S;
            np = (*P1).n;
            stat_npatterns+=np;
            isMotif = selectionq_sel(P,L,g,np,ns,k,m,N,thres,selected_stems);
            for (jjj = 0; jjj < np; ++jjj)
               hasMotif+=isMotif[jjj];
            
          }
         }
        }

        stat_nstems+=(hasMotif>0);  

     //}
     ++i;
   }
     

  printf("Threshold used: %d\n", thres);
  printf("Number of pairs: %d\n", stat_npairs);
  printf("Number of patterns: %d\n", stat_npatterns); 
  printf("Number of motif stems: %d\n", stat_nstems);
  return 0;
 

}
